"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class StudyEntry(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "sampleDataKeys",
        "samples",
        "stats",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_8 import opencb as opencb_2_9_3

        return {
            "files": opencb_2_9_3.FileEntry,
            "issues": opencb_2_9_3.IssueEntry,
            "samples": opencb_2_9_3.SampleEntry,
            "scores": opencb_2_9_3.VariantScore,
            "secondaryAlternates": opencb_2_9_3.AlternateCoordinate,
            "stats": opencb_2_9_3.VariantStats,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_8 import opencb as opencb_2_9_3

        return {
            "org.opencb.biodata.models.variant.avro.FileEntry": opencb_2_9_3.FileEntry,
            "org.opencb.biodata.models.variant.avro.IssueEntry": opencb_2_9_3.IssueEntry,
            "org.opencb.biodata.models.variant.avro.SampleEntry": opencb_2_9_3.SampleEntry,
            "org.opencb.biodata.models.variant.avro.VariantScore": opencb_2_9_3.VariantScore,
            "org.opencb.biodata.models.variant.avro.AlternateCoordinate": opencb_2_9_3.AlternateCoordinate,
            "org.opencb.biodata.models.variant.avro.VariantStats": opencb_2_9_3.VariantStats,
            "org.opencb.biodata.models.variant.avro.StudyEntry": opencb_2_9_3.StudyEntry,
        }

    __slots__ = [
        "sampleDataKeys",
        "samples",
        "stats",
        "files",
        "issues",
        "scores",
        "secondaryAlternates",
        "studyId",
    ]

    def __init__(
        self,
        sampleDataKeys,
        samples,
        stats,
        files=list,
        issues=list,
        scores=list,
        secondaryAlternates=None,
        studyId=None,
        validate=None,
        **kwargs
    ):
        """Initialise the opencb_2_9_3.StudyEntry model.

        :param sampleDataKeys:
            Fields stored for each sample.
        :type sampleDataKeys: list[str]
        :param samples:
            Genotypes and other sample-related information. Each position is
            related with one sample. The content are lists of values
            in the same order than the sampleDataKeys array. The
            length of this lists must be the same as the
            sampleDataKeys field.
        :type samples: list[SampleEntry]
        :param stats:
            Statistics of the genomic variation, such as its alleles/genotype
            count or its minimum allele frequency, grouped by cohort
            name.
        :type stats: list[VariantStats]
        :param files:
            List of files from the study where the variant was present.
        :type files: list[FileEntry]
        :param issues:
        :type issues: list[IssueEntry]
        :param scores:
        :type scores: list[VariantScore]
        :param secondaryAlternates:
            Alternate alleles that appear along with a variant alternate.
        :type secondaryAlternates: None | list[AlternateCoordinate]
        :param studyId:
            Unique identifier of the study.
        :type studyId: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "2.9.3-GEL"
